<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLoadTicketsToAccessCardItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLoadTicketsToAccessCardItem
 * @subpackage Arrays
 */
class ArrayOfLoadTicketsToAccessCardItem extends AbstractStructArrayBase
{
    /**
     * The LoadTicketsToAccessCardItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\LoadTicketsToAccessCardItem[]
     */
    public $LoadTicketsToAccessCardItem;
    /**
     * Constructor method for ArrayOfLoadTicketsToAccessCardItem
     * @uses ArrayOfLoadTicketsToAccessCardItem::setLoadTicketsToAccessCardItem()
     * @param \patest\StructType\LoadTicketsToAccessCardItem[] $loadTicketsToAccessCardItem
     */
    public function __construct(array $loadTicketsToAccessCardItem = array())
    {
        $this
            ->setLoadTicketsToAccessCardItem($loadTicketsToAccessCardItem);
    }
    /**
     * Get LoadTicketsToAccessCardItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\LoadTicketsToAccessCardItem[]|null
     */
    public function getLoadTicketsToAccessCardItem()
    {
        return isset($this->LoadTicketsToAccessCardItem) ? $this->LoadTicketsToAccessCardItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLoadTicketsToAccessCardItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLoadTicketsToAccessCardItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLoadTicketsToAccessCardItemForArrayConstraintsFromSetLoadTicketsToAccessCardItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLoadTicketsToAccessCardItemLoadTicketsToAccessCardItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfLoadTicketsToAccessCardItemLoadTicketsToAccessCardItemItem instanceof \patest\StructType\LoadTicketsToAccessCardItem) {
                $invalidValues[] = is_object($arrayOfLoadTicketsToAccessCardItemLoadTicketsToAccessCardItemItem) ? get_class($arrayOfLoadTicketsToAccessCardItemLoadTicketsToAccessCardItemItem) : sprintf('%s(%s)', gettype($arrayOfLoadTicketsToAccessCardItemLoadTicketsToAccessCardItemItem), var_export($arrayOfLoadTicketsToAccessCardItemLoadTicketsToAccessCardItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LoadTicketsToAccessCardItem property can only contain items of type \patest\StructType\LoadTicketsToAccessCardItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LoadTicketsToAccessCardItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\LoadTicketsToAccessCardItem[] $loadTicketsToAccessCardItem
     * @return \patest\ArrayType\ArrayOfLoadTicketsToAccessCardItem
     */
    public function setLoadTicketsToAccessCardItem(array $loadTicketsToAccessCardItem = array())
    {
        // validation for constraint: array
        if ('' !== ($loadTicketsToAccessCardItemArrayErrorMessage = self::validateLoadTicketsToAccessCardItemForArrayConstraintsFromSetLoadTicketsToAccessCardItem($loadTicketsToAccessCardItem))) {
            throw new \InvalidArgumentException($loadTicketsToAccessCardItemArrayErrorMessage, __LINE__);
        }
        if (is_null($loadTicketsToAccessCardItem) || (is_array($loadTicketsToAccessCardItem) && empty($loadTicketsToAccessCardItem))) {
            unset($this->LoadTicketsToAccessCardItem);
        } else {
            $this->LoadTicketsToAccessCardItem = $loadTicketsToAccessCardItem;
        }
        return $this;
    }
    /**
     * Add item to LoadTicketsToAccessCardItem value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\LoadTicketsToAccessCardItem $item
     * @return \patest\ArrayType\ArrayOfLoadTicketsToAccessCardItem
     */
    public function addToLoadTicketsToAccessCardItem(\patest\StructType\LoadTicketsToAccessCardItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\LoadTicketsToAccessCardItem) {
            throw new \InvalidArgumentException(sprintf('The LoadTicketsToAccessCardItem property can only contain items of type \patest\StructType\LoadTicketsToAccessCardItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LoadTicketsToAccessCardItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\LoadTicketsToAccessCardItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\LoadTicketsToAccessCardItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\LoadTicketsToAccessCardItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\LoadTicketsToAccessCardItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\LoadTicketsToAccessCardItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LoadTicketsToAccessCardItem
     */
    public function getAttributeName()
    {
        return 'LoadTicketsToAccessCardItem';
    }
}
